function [img_2]=spatExtrap (img,bs,sas)
%img - image to be concealed
%bs - Block size
% sas - size of support area
img_2=img;
M=size(img,1);
N=size(img,2);

for(i=0:M-1)
    for(j=0:N-1)
        w(i+1,j+1)=0.74^sqrt((i-M/2)^2+(j-N/2)^2);
    end
end
%w=ones(M,N);
w(sas+1:sas+bs, sas+1:sas+bs)=0;
W=fft2(double(w));
W=[W,W;W,W];

for(layer=1:size(img,3))
%    IMG=fft2(double(img(:,:,layer)));
    rw=double(img(:,:,layer)).*double(w);
    RW=fft2(rw);
    G=zeros(M,N);
    G2=zeros(M,N);
    EAFlag=1;
    while (EAFlag)
        for(k=0:M-1)
            for (l=0:N/2)
                if((k==0&&(l==0||l==N/2))||(k==M/2&&(l==0||l==N/2)))
                    EA(k+1,l+1)=2*((RW(k+1,l+1)^2)/W(1,1));
                else
                    if((l~=0||k<=M/2)&&(l~=N/2||k<=M/2))
                        EA(k+1,l+1)=2*(abs(RW(k+1,l+1))^2*W(1,1)-real(RW(k+1,l+1)^2*conj(W(2*k+1,2*l+1))))/(W(1,1)^2-abs(W(2*k+1,2*l+1))^2);
                    else
                        EA(k+1,l+1)=0;
                    end
                end
            end
        end
        [maxEA,u]=max(EA);
        [maxEA,v]=max(maxEA);
        u=u(v);
        v=v-1;
        u=u-1;
        if(abs(maxEA)<150)
            EAFlag=0;
            break;
        end;
        if((u==0&&(v==0||v==N/2))||(u==M/2&&(v==0||v==N/2)))
           deltC=M*N*RW(u+1, v+1)/W(1,1);
        else
            deltC=2*M*N*(RW(u+1, v+1)*W(1,1)-conj(RW(u+1, v+1))*W(2*u+1, 2*v+1))/(W(1,1)^2-abs(W(2*u+1, 2*v+1))^2);
        end
        G(u+1, v+1)=G(u+1, v+1)+deltC;
        if(u==0)
            y1=M;
        else
            y1=u;
        end
        if(v==0)
            x1=N;
        else
            x1=v;
        end
       G(M-y1+1, N-x1+1)=G(M-y1+1, N-x1+1)+conj(deltC);

       for(k=0:M-1)
            for (l=0:N-1)
                if(k-u<0)
                    y1=k-u+M;
                else
                    y1=k-u;
                end
                if(l-v<0)
                    x1=l-v+N;
                else
                    x1=l-v;
                end
                if(k-(M-u)<0)
                    y2=k+u;
                else
                    y2=k-(M-u);
                end
                if(l-(N-v)<0)
                    x2=l+v;
                else
                    x2=l-(N-v);
                end
                RW(k+1,l+1)=RW(k+1,l+1)-(deltC*W(y1+1,x1+1)+conj(deltC)*W(y2+1,x2+1))/(2*M*N);
            end
        end
    end
    gfinal=uint8(abs(ifft2(G))/2);
    img_2(sas+1:sas+bs, sas+1:sas+bs,layer)=gfinal(sas+1:sas+bs, sas+1:sas+bs);
end




                

